package cn.com.ty.lift.system.settings.controller;


import cn.com.ty.lift.system.settings.dao.entity.GlobalSet;
import cn.com.ty.lift.system.settings.service.impl.GlobalSetServiceImpl;
import cn.com.xwy.boot.web.dto.RestResponse;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 全局设置 前端控制器
 * </p>
 *
 * @author wang-hai-cheng
 * @since 2019-12-13
 */
@RestController
@RequestMapping("/set")
@AllArgsConstructor
public class GlobalSetController {
    private final GlobalSetServiceImpl globalSetService;

    /**
     * @param globalSet
     * @return 操作结果
     * @description 获取维保公司的全局设置列表
     * @date 2019/12/13 16:23
     */
    @PostMapping("list")
    public RestResponse sets(@RequestBody GlobalSet globalSet) {
        List<Map<String, Object>> globalSets = globalSetService
                .listMaps(new QueryWrapper<GlobalSet>()
                        .select("id", "type", "value", "code", "company_id companyId")
                        .eq("company_id", globalSet.getCompanyId()));
        if (globalSets.isEmpty()) {
            return RestResponse.success();
        }
        return RestResponse.success(globalSets, "成功");
    }

    /**
     * @param globalSets
     * @return 操作结果
     * @description 根据id更新维保公司的全局设置
     * @date 2019/12/13 16:24
     */
    @PostMapping("/modify")
    public RestResponse modify(@RequestBody List<GlobalSet> globalSets) {
        globalSets.forEach(globalSet -> globalSet.setUpdateTime(LocalDateTime.now()));
        if (globalSetService.updateBatchById(globalSets)) {
            return RestResponse.success(null, "成功");
        }
        return RestResponse.success();
    }
}